﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace ELTE.Basics.University
{
    class Program
    {
        static void Main(string[] args)
        {
            List<UniversityCitizen> citizens = new List<UniversityCitizen>();

            citizens.Add(new Student("Huba Hugó")); // polimorfizsmut használunk a lista feltöltésére
            citizens.Add(new Student("Sánta Rezső"));
            citizens.Add(new Teacher("Kis Ferenc"));
            Course c1 = (citizens[2] as Teacher).CreateCourse("Lazulás"); // típuskonverzió a műveletek használatához
            Course c2 = (citizens[2] as Teacher).CreateCourse("Pihizés");
            (citizens[0] as Student).SignForCourse(c1);
            (citizens[0] as Student).SignForCourse(c2);
            (citizens[1] as Student).SignForCourse(c2);

            Console.WriteLine("Egyetemi polgárok:");
            Console.WriteLine(citizens.Select(citizen => (citizen is Teacher) ? 
                                                 citizen.Name + " (" + citizen.UniversityCode + "), oktató" :
                                                 citizen.Name + " (" + citizen.UniversityCode + "), hallgató")
                                      .Aggregate((x, y) => x + Environment.NewLine + y));
               // a tartalmat aggregáljuk, soronként kapunk egyet
            Console.WriteLine("Kurzusok:");
            Console.WriteLine(Course.ListedCourseNames.Select(courseName => Course.GetCourse(courseName))
                                                      .Select(course => course.Name + ", létszám: " + course.StudentCount)
                                                      .Aggregate((x, y) => x + Environment.NewLine + y));
               // a nevekből visszakapjuk a kurzusokat, majd aggregálva kiírjuk őket
            Console.ReadKey();
        }
    }
}
