﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace ELTE.Basics.University
{
    /// <summary>
    /// Egyetemi oktató típusa.
    /// </summary>
    class Teacher : UniversityCitizen
    {
        /// <summary>
        /// Egyetemi oktató létrehozása.
        /// </summary>
        /// <param name="name">Oktató neve.</param>
        public Teacher(String name) : base(name) // ős konstruktorának meghívása
        { // egyéb tevékenység nem kell
        }

        /// <summary>
        /// Kurzus létrehozása.
        /// </summary>
        /// <param name="name">Kurzus neve.</param>
        /// <returns></returns>
        public Course CreateCourse(String name)
        {
            Course c = new Course(this, name); // nyílt rekurzió használata az oktató objektum átadásával
            _Courses.Add(c);
            return c;
        }

        /// <summary>
        /// Kurzus lekérdezése.
        /// </summary>
        /// <param name="name">Kurzus neve.</param>
        /// <returns></returns>
        public Course GetCourse(String name)
        {
            return _Courses.Where(course => course.Name == name).FirstOrDefault();
        }
        
        /// <summary>
        /// Oktatók neveinek lekérdezése.
        /// </summary>
        public static List<String> ListedTeacherNames
        {
            get
            {
                return _ListOfCitizens.Where(citizen => citizen is Teacher).Select(citizen => citizen.Name).ToList();
            }
        }

    }
}
